import java.io.IOException;
import java.util.Arrays;
import java.util.Iterator;
import java.util.List;

import com.fasterxml.jackson.databind.ObjectMapper;
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.JsonNode;
import com.mashape.unirest.http.Unirest;
import com.mashape.unirest.http.exceptions.UnirestException;


public class YouAreEll {
    List<Id> myObjects;

    public static void main(String[] args) {
        YouAreEll urlhandler = new YouAreEll();
        urlhandler.get_messages();
    }

    public void addUser(String name, String gh){
        try {
            HttpResponse<JsonNode> jsonResponse
                    = Unirest.post("http://zipcode.rocks:8085/ids")
                    .body("{\"userid\":\"-\", \"github\":\""+ gh +"\", \"name\":\"" + name + "\"}")
                    .asJson();
        } catch (UnirestException e) {
            System.out.println("Error");
        }
    }

    public void renameUser(String name){
        try {
            HttpResponse<JsonNode> jsonResponse
                    = Unirest.put("http://zipcode.rocks:8085/ids")
                    .body("{\"userid\":\"-\", \"github\":\"vincesima\", \"name\":\"" + name + "\"}")
                    .asJson();
        } catch (UnirestException e) {
            System.out.println("Error");
        }
    }

    public void send_message_to_all(String message) {
        try {
            HttpResponse<JsonNode> jsonResponse
                    = Unirest.post("http://zipcode.rocks:8085/ids/vincesima/messages")
                    .body("{\"fromid\":\"vincesima\", \"toid\":\"\", \"message\":\"" + message + "\"}")
                    .asJson();
        } catch (UnirestException e) {
            System.out.println("Error");
        }
    }

    public void send_message_to_specific(String message, String toid) {
        try {
            HttpResponse<JsonNode> jsonResponse
                    = Unirest.post("http://zipcode.rocks:8085/ids/vincesima/messages")
                    .body("{\"fromid\":\"vincesima\", \"toid\":\"" + toid + "\", \"message\":\"" + message + "\"}")
                    .asJson();
        } catch (UnirestException e) {
            System.out.println("Error");
        }
    }

    public String get_ids() {
        StringBuilder sb = new StringBuilder();
        try {
            String userJson = this.MakeURLCall("/ids", "GET", "");
            ObjectMapper objectMapper = new ObjectMapper();
            List<Id> myObjects = Arrays.asList(objectMapper.readValue(userJson, Id[].class));
            for (Iterator<Id> iter = myObjects.iterator(); iter.hasNext(); ) {
                Id element = iter.next();
                sb.append("Name: " + element.getName() + "\n");
                sb.append("GitHub: " + element.getGithub() + "\n");
                sb.append("UserID: " + element.getUserid() + "\n\n");
            }
        } catch (IOException e) {
            System.out.println("Error");
        }
        return sb.toString();
    }

    public String get_messages() {
        StringBuilder sb = new StringBuilder();
        try {
            String userJson = this.MakeURLCall("/messages", "GET", "");
            //System.out.println(userJson);
            ObjectMapper objectMapper = new ObjectMapper();
            List<Message> myObjects = Arrays.asList(objectMapper.readValue(userJson, Message[].class));
            for (Iterator<Message> iter = myObjects.iterator(); iter.hasNext(); ) {
                Message element = iter.next();
                formatMessage(element, sb);

            }
        } catch (IOException e) {
            System.out.println("Error");
        }
        System.out.println(sb.toString());
        return sb.toString();
    }

    public String get_my_messages() {
        StringBuilder sb = new StringBuilder();
        try {
            String userJson = this.MakeURLCall("/ids/vincesima/messages", "GET", "");
            ObjectMapper objectMapper = new ObjectMapper();
            List<Message> myObjects = Arrays.asList(objectMapper.readValue(userJson, Message[].class));
            for (Iterator<Message> iter = myObjects.iterator(); iter.hasNext(); ) {
                Message element = iter.next();
                formatMessage(element, sb);

            }
        } catch (IOException e) {
            System.out.println("Error");
        }
        return sb.toString();

    }

    public String get_messages_from(String user){
        StringBuilder sb = new StringBuilder();
        try {
            String userJson = this.MakeURLCall("/ids/vincesima/from/"+user, "GET", "");
            ObjectMapper objectMapper = new ObjectMapper();
            List<Message> myObjects = Arrays.asList(objectMapper.readValue(userJson, Message[].class));
            for (Iterator<Message> iter = myObjects.iterator(); iter.hasNext(); ) {
                Message element = iter.next();
                formatMessage(element, sb);
            }
        } catch (IOException e) {
            System.out.println("Error");
        }
        return sb.toString();
    }

    public String formatMessage(Message element, StringBuilder sb){
        sb.append("From: " + element.getFromid() + "\n");
        sb.append("To: " + element.getToid() + "\n");
        sb.append("Message: " + element.getMessage() + "\n");
        sb.append("Timestamp: " + element.getTimestamp() + "\n");
        sb.append("Sequence: " + element.getSequence() + "\n\n");
        return sb.toString();
    }

    public String MakeURLCall(String mainurl, String method, String jpayload) {
        try {
            HttpResponse<com.mashape.unirest.http.JsonNode> jsonResponse = null;

            if (method.equals("GET")) {
                jsonResponse = Unirest.get("http://zipcode.rocks:8085/{method}").routeParam("method", mainurl).asJson();

            } else if (method.equals("POST")) {
                jsonResponse = Unirest.post("http://zipcode.rocks:8085/{method}")
                        .routeParam("method", mainurl)
                        .body(jpayload)
                        .asJson();
            }

            return jsonResponse.getBody().toString();

        } catch (UnirestException e) {
            return "nada";
        }
    }
}
